PLaSK library

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
plask::GeometryObjectLeaf< dim >::SolidMaterial Struct Reference

`#include <plask/geometry/leaf.hpp>`

Inheritance diagram for plask::GeometryObjectLeaf< dim >::SolidMaterial:
[legend]
Collaboration diagram for plask::GeometryObjectLeaf< dim >::SolidMaterial:
[legend]

## Public Member Functions
| SolidMaterial ()=default
| SolidMaterial (shared_ptr< Material > material)
virtual shared_ptr< Material > | getMaterial (const GeometryObjectLeaf< dim > &PLASK_UNUSED(thisObj), const DVec &PLASK_UNUSED(p)) const override
shared_ptr< Material > | singleMaterial () const override
| Get material only if it this provider represents solid material (if getMaterial returns value independent from arguments).
SolidMaterial * | clone () const override
shared_ptr< Material > | getRepresentativeMaterial () const override
| Get representative material of this provider (typically material which is returned in center of object).
bool | isUniform (Primitive< 3 >::Direction PLASK_UNUSED(direction)) const override
XMLWriter::Element & | writeXML (XMLWriter::Element &dest_xml_object, const AxisNames &axes) const override
Public Member Functions inherited from plask::GeometryObjectLeaf< dim >::MaterialProvider
virtual shared_ptr< Material > | getMaterial (const GeometryObjectLeaf< dim > &thisObj, const DVec &p) const =0
virtual bool | isUniform (Primitive< 3 >::Direction direction) const =0
virtual | ~MaterialProvider ()

## Public Attributes
shared_ptr< Material > | material

## Detailed Description

template<int dim>
struct plask::GeometryObjectLeaf< dim >::SolidMaterial

Definition at line 67 of file leaf.hpp.

## Constructor & Destructor Documentation

## ◆ SolidMaterial() [1/2]

template<int dim>

plask::GeometryObjectLeaf< dim >::SolidMaterial::SolidMaterial | ( |  | ) |
| default

## ◆ SolidMaterial() [2/2]

template<int dim>

plask::GeometryObjectLeaf< dim >::SolidMaterial::SolidMaterial | ( | shared_ptr< Material > | material | ) |
| inline

Definition at line 72 of file leaf.hpp.

## Member Function Documentation

## ◆ clone()

template<int dim>

SolidMaterial * plask::GeometryObjectLeaf< dim >::SolidMaterial::clone | ( |  | ) | const
| inline override virtual

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 81 of file leaf.hpp.

## ◆ getMaterial()

template<int dim>

virtual shared_ptr< Material > plask::GeometryObjectLeaf< dim >::SolidMaterial::getMaterial | ( | const GeometryObjectLeaf< dim > & | PLASK_UNUSEDthisObj,
|  | const DVec & | PLASK_UNUSEDp
| ) |  | const
| inline override virtual

Definition at line 74 of file leaf.hpp.

## ◆ getRepresentativeMaterial()

template<int dim>

shared_ptr< Material > plask::GeometryObjectLeaf< dim >::SolidMaterial::getRepresentativeMaterial | ( |  | ) | const
| inline override virtual

Get representative material of this provider (typically material which is returned in center of object).

Returns
  representative material of this provider

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 83 of file leaf.hpp.

## ◆ isUniform()

template<int dim>

bool plask::GeometryObjectLeaf< dim >::SolidMaterial::isUniform | ( | Primitive< 3 >::Direction | PLASK_UNUSEDdirection | ) | const
| inline override

Definition at line 85 of file leaf.hpp.

## ◆ singleMaterial()

template<int dim>

shared_ptr< Material > plask::GeometryObjectLeaf< dim >::SolidMaterial::singleMaterial | ( |  | ) | const
| inline override virtual

Get material only if it this provider represents solid material (if getMaterial returns value independent from arguments).

Returns
  material or nullptr if it is not solid

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 79 of file leaf.hpp.

## ◆ writeXML()

template<int dim>

XMLWriter::Element & plask::GeometryObjectLeaf< dim >::SolidMaterial::writeXML | ( | XMLWriter::Element & | dest_xml_object,
|  | const AxisNames & | axes
| ) |  | const
| override virtual

Implements plask::GeometryObjectLeaf< dim >::MaterialProvider.

Definition at line 23 of file leaf.cpp.

## Member Data Documentation

## ◆ material

template<int dim>

shared_ptr<Material> plask::GeometryObjectLeaf< dim >::SolidMaterial::material

Definition at line 68 of file leaf.hpp.

The documentation for this struct was generated from the following files:

- plask/geometry/leaf.hpp
- plask/geometry/leaf.cpp